libstdc++: std::_Vector_base< _Tp, _Alloc > Struct Template Reference

libstdc++

std::_Vector_base< _Tp, _Alloc > Struct Template Reference

`#include <stl_vector.h>`

Inheritance diagram for std::_Vector_base< _Tp, _Alloc >:
[legend]

## Public Types
typedef __gnu_cxx::__alloc_traits< _Alloc >::template rebind< _Tp >::other | _Tp_alloc_type
typedef _Alloc | allocator_type
typedef __gnu_cxx::__alloc_traits< _Tp_alloc_type >::pointer | pointer

## Public Member Functions
constexpr | _Vector_base (_Tp_alloc_type &&__a) noexcept
| _Vector_base (_Vector_base &&)=default
constexpr | _Vector_base (_Vector_base &&__x, const allocator_type &__a)
constexpr | _Vector_base (const allocator_type &__a) noexcept
constexpr | _Vector_base (const allocator_type &__a, _Vector_base &&__x)
constexpr | _Vector_base (size_t __n)
constexpr | _Vector_base (size_t __n, const allocator_type &__a)
constexpr pointer | _M_allocate (size_t __n)
constexpr void | _M_deallocate (pointer __p, size_t __n)
constexpr const _Tp_alloc_type & | _M_get_Tp_allocator () const noexcept
constexpr _Tp_alloc_type & | _M_get_Tp_allocator () noexcept
constexpr allocator_type | get_allocator () const noexcept

## Public Attributes
_Vector_impl | _M_impl

## Protected Member Functions
constexpr void | _M_create_storage (size_t __n)

## Detailed Description

template<typename _Tp, typename _Alloc>
struct std::_Vector_base< _Tp, _Alloc >

See bits/stl_deque.h's _Deque_base for an explanation.

Definition at line 91 of file stl_vector.h.

## Member Typedef Documentation

## ◆ _Tp_alloc_type

template<typename _Tp, typename _Alloc>

typedef __gnu_cxx::__alloc_traits<_Alloc>::template rebind<_Tp>::other std::_Vector_base< _Tp, _Alloc >::_Tp_alloc_type

Definition at line 94 of file stl_vector.h.

## ◆ allocator_type

template<typename _Tp, typename _Alloc>

typedef _Alloc std::_Vector_base< _Tp, _Alloc >::allocator_type

Definition at line 303 of file stl_vector.h.

## ◆ pointer

template<typename _Tp, typename _Alloc>

typedef __gnu_cxx::__alloc_traits<_Tp_alloc_type>::pointer std::_Vector_base< _Tp, _Alloc >::pointer

Definition at line 96 of file stl_vector.h.

## Constructor & Destructor Documentation

## ◆ _Vector_base() [1/6]

template<typename _Tp, typename _Alloc>

std::_Vector_base< _Tp, _Alloc >::_Vector_base | ( | const allocator_type & | __a | ) |
| inlineconstexprnoexcept

Definition at line 327 of file stl_vector.h.

## ◆ _Vector_base() [2/6]

template<typename _Tp, typename _Alloc>

std::_Vector_base< _Tp, _Alloc >::_Vector_base | ( | size_t | __n | ) |
| inlineconstexpr

Definition at line 333 of file stl_vector.h.

## ◆ _Vector_base() [3/6]

template<typename _Tp, typename _Alloc>

std::_Vector_base< _Tp, _Alloc >::_Vector_base | ( | size_t | __n,
|  | const allocator_type & | __a )
| inlineconstexpr

Definition at line 339 of file stl_vector.h.

## ◆ _Vector_base() [4/6]

template<typename _Tp, typename _Alloc>

std::_Vector_base< _Tp, _Alloc >::_Vector_base | ( | _Tp_alloc_type && | __a | ) |
| inlineconstexprnoexcept

Definition at line 349 of file stl_vector.h.

## ◆ _Vector_base() [5/6]

template<typename _Tp, typename _Alloc>

std::_Vector_base< _Tp, _Alloc >::_Vector_base | ( | _Vector_base< _Tp, _Alloc > && | __x,
|  | const allocator_type & | __a )
| inlineconstexpr

Definition at line 353 of file stl_vector.h.

## ◆ _Vector_base() [6/6]

template<typename _Tp, typename _Alloc>

std::_Vector_base< _Tp, _Alloc >::_Vector_base | ( | const allocator_type & | __a,
|  | _Vector_base< _Tp, _Alloc > && | __x )
| inlineconstexpr

Definition at line 367 of file stl_vector.h.

## ◆ ~_Vector_base()

template<typename _Tp, typename _Alloc>

std::_Vector_base< _Tp, _Alloc >::~_Vector_base | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 373 of file stl_vector.h.

## Member Function Documentation

## ◆ _M_allocate()

template<typename _Tp, typename _Alloc>

pointer std::_Vector_base< _Tp, _Alloc >::_M_allocate | ( | size_t | __n | ) |
| inlineconstexpr

Definition at line 386 of file stl_vector.h.

## ◆ _M_create_storage()

template<typename _Tp, typename _Alloc>

void std::_Vector_base< _Tp, _Alloc >::_M_create_storage | ( | size_t | __n | ) |
| inlineconstexprprotected

Definition at line 405 of file stl_vector.h.

## ◆ _M_deallocate()

template<typename _Tp, typename _Alloc>

void std::_Vector_base< _Tp, _Alloc >::_M_deallocate | ( | pointer | __p,
|  | size_t | __n )
| inlineconstexpr

Definition at line 394 of file stl_vector.h.

## ◆ _M_get_Tp_allocator() [1/2]

template<typename _Tp, typename _Alloc>

const _Tp_alloc_type & std::_Vector_base< _Tp, _Alloc >::_M_get_Tp_allocator | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 312 of file stl_vector.h.

## ◆ _M_get_Tp_allocator() [2/2]

template<typename _Tp, typename _Alloc>

_Tp_alloc_type & std::_Vector_base< _Tp, _Alloc >::_M_get_Tp_allocator | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 307 of file stl_vector.h.

## ◆ get_allocator()

template<typename _Tp, typename _Alloc>

allocator_type std::_Vector_base< _Tp, _Alloc >::get_allocator | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 317 of file stl_vector.h.

## Member Data Documentation

## ◆ _M_impl

template<typename _Tp, typename _Alloc>

_Vector_impl std::_Vector_base< _Tp, _Alloc >::_M_impl

Definition at line 382 of file stl_vector.h.

The documentation for this struct was generated from the following file:

- stl_vector.h